<template>
    <div class="card orders home__part">
        <div class="card__header">
            <h2 class="card__title">Заказы</h2>
            <UpdateButton className="orders__update" @update="updateOrders" />
        </div>
        <div class="card__content">
            <ul v-if="orders.list.length" class="orders__list list">
                <OrdersItem
                    @start-drag="onDragStart"
                    @stop-drag="onDragEnd"
                    @to-delivery="toDelivery"
                    @show-details="showDetails"
                    @remove="remove"
                    v-for="(order, i) in orders.list"
                    :key="i"
                    :order="order"
                />
            </ul>
            <AppLoader v-else-if="orders.isLoading" />
            <div v-else class="orders__empty">В данный момент заказов нет</div>
            <div
                v-if="dragEvent.isStart"
                @drop="onDrop($event)"
                class="card pt-sm card--danger card--outline"
                @dragenter="onDragEnter"
                @dragover.prevent
                @dragleave="onDragLeave"
                :class="{'droping': dragEvent.isEnter, 'dragged': dragEvent.isStart}"
            >
                Отменить заказ
            </div>
        </div>
        <AppModal
            @close="hideDetails"
            @to-delivery="toDeliveryForModal"
            @remove="removeForModal"
            v-if="viewedOrder.isActive"
            :id="viewedOrder.id"
        />
    </div>
</template>

<script>
import UpdateButton from '../Buttons/UpdateButton';
import OrdersItem from './OrdersItem';
import AppLoader from '../AppLoader';
import AppModal from '../AppModal';

export default {
    components: {
        UpdateButton, OrdersItem, AppLoader, AppModal
    },
    data() {
        return {
            orders: {
                isLoading: false,
                list: []
            },
            viewedOrder: {
                id: null,
                isActive: false
            },
            dragEvent: {
                isStart: false,
                isEnter: false
            },
            FETCH_URL: 'https://demo-api.vsdev.space/api/orders_admin/20210603/'
        }
    },
    methods: {
        async updateOrders() {
            console.log('order query');
            this.orders.list = [];
            this.orders.isLoading = true;

            const URL = this.FETCH_URL + 'orders';
            
            let response = await fetch(URL);
            if (response.ok) {
                this.orders.list = await response.json();
                this.orders.isLoading = false;
            } else {
                setTimeout(this.updateOrders, 5000);
            }
        },

        async toDelivery(id) {
            const URL = this.FETCH_URL + 'orders/' + id + '/delivery';
            try {
                let response = await fetch(URL, {
                    method: 'POST'
                });

                if (!response.ok) console.log('error');
            } catch {
                console.log('Error');
            }
        },

        async remove(id) {
            const URL = this.FETCH_URL + 'orders/' + id;

            try {
                let response = await fetch(URL, {
                    method: 'DELETE'
                });

                if (response.ok) {
                    const index = this.orders.list.findIndex(element => element.id == id);
                    this.orders.list.splice(index, 1);
                } else {
                    console.log('error');
                }
            } catch {
                console.log('error');
            }
        },

        async showDetails(id) {
            this.viewedOrder.id = id;
            this.viewedOrder.isActive = true;
        },

        hideDetails() {
            this.viewedOrder.id = null;
            this.viewedOrder.isActive = false;
        },

        removeForModal() {
            this.remove(this.viewedOrder.id);
            this.hideDetails();
        },

        toDeliveryForModal() {
            this.toDelivery(this.viewedOrder.id);
            this.hideDetails();
        },

        onDragStart(event, item) {
            event.dataTransfer.setData('itemID', item.id);
            event.dataTransfer.setData('itemType', 'order');
            this.dragEvent.isStart = true;
        },

        onDrop(event) {
            const id = event.dataTransfer.getData('itemID');
            this.remove(id);
        },

        onDragEnter() {
            this.dragEvent.isEnter = true;
        },

        onDragLeave() {
            this.dragEvent.isEnter = false;
        },

        onDragEnd() {
            this.dragEvent.isStart = false;
            this.dragEvent.isEnter = false;
        }
    },
    mounted() {
        this.updateOrders();
    }
}
</script>

<style>

</style>